//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef __CONFIG_H__
#define __CONFIG_H__

// c'est ce numro qu'il faut incrmenter  chaque modification sur la structure du fichier config
#define CONFIG_VERSION "5"

#include <SDL.h>

#ifdef __unix
	#include <sys/stat.h>
#endif

#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <cstdlib>
#include <map>
#include <dirent.h>

#include "Defines.h"
#include "Templates.h"

using namespace std;

typedef map<string, string> mapParametre;

// No description
class Config
{
  //*******************
  //* variables membres
    public:
    	string  _LogFilename;
    	mapParametre _Parametre;

  //*******************
  //* fonctions membres
	public:
		Config();
		~Config();

		// Fonction qui change un paramtre dans le fichier
		void set(string , string);
		// Fonction qui renvoi le paramtre qui se trouve dans le fichier.
		string get(string);

    private:
        void initFichier(void);
        void initFileName(void); // dfinit le nom du fichier
        void lireFichier(void);
        void ecrireFichier(void);
        string lireFichierInitLangue(void);

        bool isReadable( const string & file);
};

#endif // __CONFIG_H__
