//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef __FOND_ECRAN_H__
#define __FOND_ECRAN_H__

#include <SDL.h>

#include "Defines.h"
#include "Screen.h"
#include "Piece.h"

#define FD_ECR_SPRITE_NAME      "fond de l'cran"
#define FD_ECR_LOGO_SPRITE_NAME "logo du fond de l'cran"
#define FD_ECR_SPRITE_LOGO_N    "logo de natsimhan logo_N"

class Lineo;

#define FD_ECR_VIERGE               0x01
#define FD_ECR_LINEO_SMALL          0x02
#define FD_ECR_LINEO_LARGE          0x04
#define FD_ECR_LINEO_LARGE_A50      0x08
#define FD_ECR_PIECE_P3D            0x10
#define FD_ECR_NO_LOGO_NATSIMHAN    0x20
#define FD_ECR_NO_PIECES_3D         0x40

// affiche le fond de l'cran du jeu avec ou sans le logo lino dans diffrents formats
// Le format FD_ECR_LINEO_SMALL peut tre combin avec un autre  l'aide de |
class FondEcran
{
  //*******************
  //* variables membres
	private:
	    Lineo *_AppLineo;
        Uint32 _Type;
        Piece* _Piece1;
        Piece* _Piece2;

  //*******************
  //* fonctions membres
	public:
		FondEcran(Lineo *app_lineo, Uint32 type);
		~FondEcran();

};

#endif // __FOND_ECRAN_H__
