//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "GeneriqueFin.h"
#include "Lineo.h"

GeneriqueFin::GeneriqueFin(Lineo *app_lineo)
{
	_AppLineo = app_lineo;
	_Compteur=0;
    // on initialise le fond d'cran Lino
    _FondEcranLineo = new FondEcran(_AppLineo, FD_ECR_LINEO_LARGE|FD_ECR_PIECE_P3D);
	// on affiche l'adresse du site de Lino
	_UrlLineoId = _AppLineo->_VTexte->add(FONT_36_YELLOW,"http://lineo.natsimhan.com",TEXTE_X_CENTER|TEXTE_Y_BOTTOM,0,50,Z_MENU_TEXTE);
	// on affiche l'adresse email du contact de Lino
	_EmaiLineoId = _AppLineo->_VTexte->add(FONT_26_YELLOW,"lineo.contact@natsimhan.com",TEXTE_X_CENTER|TEXTE_Y_BOTTOM,0,10,Z_MENU_TEXTE);
    // on affiche le logo GNU GPL en haut  gauche
    SDL_Rect rec_src,rec_des;
    rec_src.x= 0;
    rec_des.x=10;
    rec_src.y= 0;
    rec_des.y=10;
    rec_src.w=rec_des.w= 98;
    rec_src.h=rec_des.h=121;
	_AppLineo->_Screen->addSprite(GENERIQUE_FIN_LOGO_GNU_GPL,(string)(DATA_PATH)+"logo_GNU_GPL_blanc.png",Z_MENU_TEXTE);
    _AppLineo->_Screen->addSpriteImage(GENERIQUE_FIN_LOGO_GNU_GPL,rec_src,rec_des);
    // on affiche le logo SDL powered en haut  droite
    rec_src.x= 0;
    rec_des.x=SCREEN_W - 220;
    rec_src.y= 0;
    rec_des.y=10;
    rec_src.w=rec_des.w=210;
    rec_src.h=rec_des.h=137;
	_AppLineo->_Screen->addSprite(GENERIQUE_FIN_LOGO_SDL_PWRD,(string)(DATA_PATH)+"logo_SDL_powered.png",Z_MENU_TEXTE);
    _AppLineo->_Screen->addSpriteImage(GENERIQUE_FIN_LOGO_SDL_PWRD,rec_src,rec_des);
    // on arrte doucement la musique
    Musique::getInstance()->decrechendo(6000);
}

GeneriqueFin::~GeneriqueFin()
{
    _AppLineo->_VTexte->del(_UrlLineoId);
    _AppLineo->_VTexte->del(_EmaiLineoId);
	delete(_FondEcranLineo);
    // on efface les sprites
    _AppLineo->_Screen->delSprite(GENERIQUE_FIN_LOGO_GNU_GPL);
    _AppLineo->_Screen->delSprite(GENERIQUE_FIN_LOGO_SDL_PWRD);
}

void GeneriqueFin::processEvents(SDL_Event *event)
{
    if (event->user.code == EVENT_TIMER)
    {
        _Compteur++;
        // on test si a fait 6 secondes que la classe a t lance
        if(_Compteur == 6*TIMER_NB_TICK_FOR_1_S){
        	_AppLineo->_Events->addEvent(EVENT_QUITTER);
        }
    }

    switch (event->type)
    {
        case SDL_MOUSEBUTTONUP:
        case SDL_KEYDOWN:
            // On quitte le gnrique de fin et le jeu...
            _AppLineo->_Events->addEvent(EVENT_QUITTER);
        break;
    }
}
