//  Lino
//  Copyright (C) 2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005-2006 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#include "Langue.h" // class's header file
#include "Lineo.h"

// class constructor
Langue::Langue(Lineo *app_lineo)
{
	_AppLineo = app_lineo;
     Lire();
}

// class destructor
Langue::~Langue()
{
}


// Fonction qui lit le fichier
void Langue::Lire()
{
    string ligne;
    istringstream buffer;

    string mot;
    string nom;
    string value;
    ifstream fichier;
    fichier.open(to_string((string)(DATA_PATH)+"lang/" + _AppLineo->_Config->get("langue") + ".ini").c_str());

    // Tant qu'il existe des lignes...
    //en fonction de l'encodage du fichier il pourrait encore rester un \r
    while ( getline( fichier, ligne, '\n' ) )
    {
        if (ligne[ligne.size()-1]=='\r'){
            ligne=ligne.substr(0,ligne.size()-1);
        }
        int i=0;

        // getline prend un fichier ou un buffer en premier parametre
        // je cre un buffer, je l'initialise puis lui met la valeur ligne
        buffer.clear();
        buffer.str(ligne);

        // getline renvoi  chaque interrogation ses lectures
        // avec pour sparateur =
        while ( getline( buffer, mot, '=') )
        {
             //if ( mot[0] != '#' )
             switch (i)
             {
                    // Premier passage avant le =
                    case 0 : nom = mot; break;

                    // Deuxieme passage apres le =
                    case 1 : value = mot; break;
             }
             i++;
        }
        _TexteLangue[nom]=value;
    }
    fichier.close();
    // on fait une copie de sauvegarde de la map des phrases afin de garder l'original
    _TexteLangueOriginal = _TexteLangue;
}

//Test si le fichier est lisible
bool Langue::is_readable( const string & file)
{
    ifstream fichier( file.c_str() );
    return fichier != 0;
}

string Langue::get(string ChoixLangue)
{
    string tampon;
    tampon = _TexteLangue[ChoixLangue];
    return (tampon);
}

// permet de remplacer un string par un autre dans l'ensemble de la map langue
void Langue::replace(string search,string replacement)
{
    // on boucle sur l'ensemble des phrases afin de remplacer ce qui est demand
    for (mapiter it = _TexteLangueOriginal.begin(); it != _TexteLangueOriginal.end(); it++){
        _TexteLangue[(*it).first] = Texte::strReplace(search, replacement, (*it).second);
    }
}
