//  Lino
//  Copyright (C) 2005 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA



#ifndef __NOEUD_IA_H__
#define __NOEUD_IA_H__

#include <SDL.h>

#include "Piece.h"
#include "LaDonne.h"


class NoeudIA
{
  //*******************
  //* variables membres
	private:
        LaDonne _Donne;
        Uint8   _NextI;
        Uint8   _NextJ;
        Uint8   _NextPieceChoisie;
        Uint8   _MatriceFormes[8][4][4];

  //*******************
  //* fonctions membres
	public:
		NoeudIA(LaDonne donne);
		~NoeudIA();

		void choisirPiece(Uint8 i); // choisie une pice dans les libres
		void placerPiece(Uint8 i, Uint8 j); // place la pice choisie sur le plateau

        inline bool isLineo(){ return _Donne.isLineo(); }
		inline Uint8 getPieceLibre(Uint8 i){ return _Donne.getPieceLibre(i); }
		inline bool isCercleLibre(Uint8 i, Uint8 j){ return _Donne.isCercleLibre(i,j); }
		
		inline Uint8 getNextI(){ return _NextI; }
		inline Uint8 getNextJ(){ return _NextJ; }
		inline Uint8 getNextPieceChoisie(){ return _NextPieceChoisie; }

    private:
        Uint8 formeToIndex(Uint8 def_forme);
};

#endif // __NOEUD_IA_H__
