//  Lino
//  Copyright (C) 2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __POP_UP_H__
#define __POP_UP_H__

#include "Langue.h"
#include "Templates.h"
#include "Fond.h"

#define POPUP_FONT_TITRE      FONT_24_WHITE
#define POPUP_FONT_TEXTE      FONT_18_WHITE

#define POPUP_TYPE_ERREUR  0
#define POPUP_TYPE_WARNING 1
#define POPUP_TYPE_INFO    2

#define POPUP_MARGE_TXT_G 20
#define POPUP_MARGE_TXT_B 42
#define POPUP_MARGE_TXT_D 42
#define POPUP_MARGE_TXT_H 60

#define POPUP_MARGE_TITRE_X 15
#define POPUP_MARGE_TITRE_Y 9

#define POPUP_BTN_MARGE_W       10
#define POPUP_BTN_MARGE_H  		 8
#define POPUP_BTN_H       		38
#define POPUP_BTN_MARGE_ENTRE_2 20
#define POPUP_BTN_MARGE_UP       0
#define POPUP_BTN_MARGE_DOWM    15

#define POPUP_MARGE_CROIX 6

#define POPUP_CROIX_W 35
#define POPUP_CROIX_H 35

#define POPUP_CROIX_IMG_OUT 0
#define POPUP_CROIX_IMG_ON  1

#define POPUP_PIECE3D_W 		60
#define POPUP_PIECE3D_H 		60
#define POPUP_PIECE3D_MARGE_X 	13
#define POPUP_PIECE3D_NB_IMG    10

#define POPUP_TITLE_BAR_MARGE_X  3
#define POPUP_TITLE_BAR_MARGE_Y  3
#define POPUP_TITLE_BAR_MARGE_W 27
#define POPUP_TITLE_BAR_H       41

#define POPUP_BTN_1 0
#define POPUP_BTN_2 1
#define POPUP_BTN_3 2

#define POPUP_SPRITE_NAME_CROIX "POPUP_SPRITE_NAME_CROIX"

#define POPUP_SPRITE_NAME_PIECE3D "POPUP_SPRITE_NAME_PIECE3D"

class Lineo;

using namespace std;

class PopUp
{
  //*******************
  //* variables membres
	private:
	    Lineo 	   *_AppLineo;
		Uint8  		_Type;
		string 		_ImageName;
		Uint32 		_TexteId;
		Uint32 		_TitreId;
		SDL_Rect 	_CroixFermer;
		Uint8  		_CroixFermerCurrent;

		SDL_Rect 	_BarreTitreRect;
        bool        _BarreTitreSurvol;
        bool        _BarreTitreDeplacable;

		SDL_Rect 	_Piece3DRect;
		Uint8  		_Piece3DCurrent;

        Uint32      _LastGetTicks;
        double      _CumulFrames;

		Uint8       _FondType;
        Fond *      _Fond;
		SDL_Rect 	_FondRect;
		Uint16		_TailleOmbre;

		Uint8       _NbBouton;
        SDL_Rect    _BtnContour[3];
        Fond *      _BtnFond[3];
        Uint32      _BtnEvent[3];
        Uint32      _BtnTxtId[3];
        bool        _BtnSurvolSouris[3];

		Uint8       _FondBtnTypeOn;
		Uint8       _FondBtnTypeOut;

  //*******************
  //* fonctions membres
	public:
		PopUp(Lineo* app_lineo, Uint8 type, string titre, string texte, string btn1_txt, Uint32 btn1_evt, string btn2_txt, Uint32 btn2_evt, string btn3_txt, Uint32 btn3_evt);
		~PopUp();
		void processEvents(SDL_Event *event);
		void refreshScreen(void); // actualise l'animation 3D
};

#endif // __POP_UP_H__
