//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


// ###################
// ce fichier contiendra diffrents templates pouvant tre utiles  plein de trucs partout dans le code

#ifndef __TEMPLATE_H__
#define __TEMPLATE_H__

#include <sstream>

using namespace std;

// cette source vient de la FAQ C++ de www.developpez.com
template<typename T>
string to_string( const T & Value )
{
    // utiliser un flux de sortie pour crer la chane
    ostringstream oss;
    // crire la valeur dans le flux
    oss << Value;
    // renvoyer une string
    return oss.str();
}

// cette source vient de la FAQ C++ de www.developpez.com
template<typename T>
Uint8 string_to_int(const T & chaine)
{
    // crer un flux  partir de la chane  convertir
    istringstream iss( chaine );
    // convertir en un int
    int nombre;
    iss >> nombre;
    return nombre;
}

// renvoie le plus grand entre A et B
template<typename T>
const T & Max( const T & A, const T & B )
{
    return A > B ? A : B;
}

// renvoie le plus petit entre A et B
template<typename T>
const T & Min( const T & A, const T & B )
{
    return A < B ? A : B;
}

#endif // __TEMPLATE_H__
