//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VFONT_H__
#define __VFONT_H__

#include <vector>
#include <string>

#include "Font.h"

class Lineo;

using namespace std;

typedef vector<Font> vfont;

// gre la liste des fonts, pour pouvoir afficher du texte de n'importe o dans le code
class VFont
{
  //*******************
  //* variables membres
    private:
	    Lineo  *_AppLineo;
        vfont 	_Fonts;

  //*******************
  //* fonctions membres
	public:
		VFont(Lineo *app_lineo);
		~VFont();
		bool add(string name_font, string name_surface, string ext);
        void movPhrase(string name_font, string phrase, Uint32 id_phrase, Sint32 offset_x, Sint32 offset_y); // dplace un texte selon un offset
		void setPhraseZIndex(string name_font, string phrase, Uint32 id_phrase, Uint32 new_z_index); // modifie le z_index d'une phrase
   		Uint32 getPhraseWidth(string name_font, string phrase); // donne la largeur d'une phrase en pixel
   		Uint32 getHeight(string name_font);
   		void phraseToImages(string name_font, string phrase, Uint32 id_phrase, SDL_Rect rect, Uint32 z_index); // transforme une phrase en autant d'image qu'il y a de lettres
        void delPhrase(string name_font, string phrase, Uint32 id_phrase); // supprime une phrase

    private:
   		vfont::iterator findFont(string name);// rcupre une Font dans la liste
};

#endif // __VFONT_H__
