//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#ifndef __VTEXTE_H__
#define __VTEXTE_H__

#include <vector>

#include <SDL.h>

#include "Texte.h"

class Lineo;

using namespace std;

typedef vector<Texte> vtexte;

class VTexte
{
  //*******************
  //* variables membres
    private:
	    Lineo  *_AppLineo;
        vtexte _Textes;
        
  //*******************
  //* fonctions membres
	public:
		VTexte(Lineo *app_lineo);
		~VTexte();
		Uint32 add(string font, string texte, char align_x_y, Uint32 z_index); // ajoute un texte  l'cran avec un alignement sans offset
		Uint32 add(string font, string texte, char align_x_y, Sint32 offset_x, Sint32 offset_y, Uint32 z_index); // ajoute un texte  l'cran avec une indication d'alignement et un offset en x et y
		Uint32 add(string font, string texte, Uint32 pos_x, Uint32 pos_y, Uint32 z_index); // ajoute un texte  l'cran avec une position
        void mov(Uint32 id_texte, Sint32 offset_x, Sint32 offset_y); // dplace un texte selon un offset
        void setZIndex(Uint32 id_texte, Uint32 new_z_index); // modifie le z_index d'un texte
        Uint32 del(Uint32 id_texte); // supprime un texte et renvoi le z_index qui tait au texte
        
   		Uint16 getTexteWidth(string name_font, string texte); // donne la largeur du texte en pixel
   		Uint16 getTexteHeight(string name_font, string texte); // donne la hauteur du texte en pixel

	private:
		Uint32 add(string font, string texte, char align, Sint32 offset_x, Sint32 offset_y, Uint32 pos_x, Uint32 pos_y, Uint32 z_index); // ajoute un texte  l'cran avec tous les paramtres de positionnement ncessaires
   		vtexte::iterator findTexte(Uint32 id_texte);// rcupre un Texte dans la liste
};

#endif // __VTEXTE_H__
