//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#include "VueCredits.h"
#include "Lineo.h"

VueCredits::VueCredits(Lineo *app_lineo, Uint16 event_retour)
{
	_AppLineo = app_lineo;
    _EventRetour = event_retour;
    // on cr le tableau avec toutes les crdits  afficher
    _CreditsString.clear();
    _CreditsFont.clear();
    _CreditsY.clear();
    _CreditsH.clear();
    _CreditsOnScreen.clear();

    _CreditsString.push_back("~ Lino ~");_CreditsFont.push_back(CREDITS_FT_GROS_TITRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Chef du projet")+"\n"
                            +_AppLineo->_Langue->get("Conception et Programmation")+"\n"
                            +_AppLineo->_Langue->get("Graphismes"));
    _CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Jonathan Buron");_CreditsFont.push_back(CREDITS_FT_GROS_TITRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Contribution pour Windows"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Pierre-Yves Bonnefoy");_CreditsFont.push_back(CREDITS_FT_TEXTE);
#ifdef Nokia770
    _CreditsString.push_back("Nokia770 port");_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Uwe Koch");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("http://www.linuxvision.de");_CreditsFont.push_back(CREDITS_FT_TEXTE_JAUNE);
#endif
    _CreditsString.push_back(_AppLineo->_Langue->get("Contribution pour Linux"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Joachim Desoutter");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("Bertrand Haut");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Traduction"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Joachim Desoutter");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Anglais"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back("Korvigello an Drouizig");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("( http://www.drouizig.org )");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Breton"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back("Simone Buron");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Suedois"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back("Uwe Koch");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Allemand"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
//    _CreditsString.push_back("Mlanie Letessier");_CreditsFont.push_back(CREDITS_FT_TEXTE);
//    _CreditsString.push_back(_AppLineo->_Langue->get("Espagnol"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Musique"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Aurlien Merle");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Beta tests"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Guillaume Plumas");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("Pierre-Yves Bonnefoy");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Remerciements a"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back("Blaise Muller");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Pour le concept dont s'inspire Lineo"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back(" ");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("L'equipe Natsimhan"));_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Qui offre gratuitement de son temps"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("pour la realisation de ce super jeu"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back(" ");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("SDL");_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Pour rendre possible une meme et bonne"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("experience de jeu sous Linux et Windows"));_CreditsFont.push_back(CREDITS_FT_COMMENTAIRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Contact"));_CreditsFont.push_back(CREDITS_FT_TITRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Visitez le site Internet"));_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("http://lineo.natsimhan.com");_CreditsFont.push_back(CREDITS_FT_TEXTE_JAUNE);
    _CreditsString.push_back(_AppLineo->_Langue->get("Ecrivez-moi"));_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("lineo.contact@natsimhan.com");_CreditsFont.push_back(CREDITS_FT_TEXTE_JAUNE);
    _CreditsString.push_back(" ");_CreditsFont.push_back(CREDITS_FT_GROS_TITRE);
    _CreditsString.push_back(" ");_CreditsFont.push_back(CREDITS_FT_GROS_TITRE);
    _CreditsString.push_back(_AppLineo->_Langue->get("merci de jouer a"));_CreditsFont.push_back(CREDITS_FT_TEXTE);
    _CreditsString.push_back("Lino");_CreditsFont.push_back(CREDITS_FT_GROS_TITRE);
    // on initialise les crdits avec diffrents paramtres qu'on calcul une "BONNEFOY" pour toute ;-)
    Uint16 y=550;
    int credits_size=_CreditsString.size();
    for(int i=0;i<credits_size;i++){
        Uint16 y_pas=0;
        if(_CreditsFont[i]==CREDITS_FT_GROS_TITRE){
            y_pas=CREDITS_FT_MARGE_GROS_TITRE;
        }else if(_CreditsFont[i]==CREDITS_FT_TITRE){
            y_pas=CREDITS_FT_MARGE_TITRE;
        }else if(_CreditsFont[i]==CREDITS_FT_TEXTE){
            y_pas=CREDITS_FT_MARGE_TEXTE;
        }else if(_CreditsFont[i]==CREDITS_FT_TEXTE_JAUNE){
            y_pas=CREDITS_FT_MARGE_TEXTE_JAUNE;
        }else if(_CreditsFont[i]==CREDITS_FT_COMMENTAIRE){
            y_pas=CREDITS_FT_MARGE_COMMENTAIRE;
        }
        y+=y_pas;
        _CreditsH.push_back(_AppLineo->_VTexte->getTexteHeight(_CreditsFont[i],_CreditsString[i]));
        _CreditsY.push_back(y);
        _CreditsId.push_back(0);
        _CreditsOnScreen.push_back(false);
        y+=_CreditsH.back();
    }
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(_AppLineo, FD_ECR_LINEO_LARGE_A50|FD_ECR_PIECE_P3D|FD_ECR_NO_PIECES_3D);
    // on affiche la bande du haut et celle du bas par dessus tout pour les fondus
    SDL_Rect rec_src,rec_des;
    rec_src.x=rec_des.x=0;
    rec_src.y=rec_des.y=0;
    rec_src.w=rec_des.w=800;
    rec_src.h=rec_des.h=600;
    _AppLineo->_Screen->addSprite(CREDITS_BANDES_SPRITE_NAME,(string)(DATA_PATH)+"fond_ecran_credits.png",Z_CREDITS_BANDES);
    _AppLineo->_Screen->addSpriteImage(CREDITS_BANDES_SPRITE_NAME,rec_src,rec_des);
    // on rcupre le premier repre pour la vitesse
    _LastGetTicks=SDL_GetTicks();
    _OffsetCumule=0.0;
    // on rafraichi l'cran une premire fois
    refreshScreen();
}

VueCredits::~VueCredits()
{
    // on efface les bandes
    _AppLineo->_Screen->delSprite(CREDITS_BANDES_SPRITE_NAME);
    // on efface tous les textes
    int credits_size=_CreditsString.size();
    for(int i=0;i<credits_size;i++){
        _AppLineo->_VTexte->del(_CreditsId[i]);
    }
	// on libre le pointeur de la classe
	delete(_FondEcran);
}

// efface les lments de la vue
void VueCredits::refreshScreen(void)
{
    // on calcul l'offset de dcalage en fonction du temps du dernier raffraichissement
    // ceci rgle la vitesse de dfilement du texte
    Uint32 new_get_ticks = SDL_GetTicks();
    _OffsetCumule += (double)(new_get_ticks - _LastGetTicks) * 0.04;
    _LastGetTicks = new_get_ticks;
    Uint32 offset = 0;
    // comme on ne peut monter que d'un pixel  la fois
	// et bien on monte pixel par pixel tant que le permet l'ofsset cumul
    while(_OffsetCumule > 1.0){
        offset++;
        _OffsetCumule -= 1.0;
    }
    // on boucle ligne aprs ligne et on voit si on l'affiche et la bouge ou non
    if(offset>0){
        int credits_size=_CreditsString.size();
        for(int i=0;i<credits_size;i++){
            Uint16 y=_CreditsY[i];
            // on est donc  l'cran
            if(y<600){
                // on est en plein affichage
                if(y>30){
                    // on affiche la ligne si ncessaire
                    if(!_CreditsOnScreen[i]){
                        _CreditsId[i] = _AppLineo->_VTexte->add(_CreditsFont[i],_CreditsString[i],TEXTE_X_CENTER,0,y,Z_CREDITS_TEXTES);
                        _CreditsOnScreen[i]=true;
                    }
                    // on bouge la ligne  l'cran
                    _AppLineo->_VTexte->mov(_CreditsId[i],0,-offset);
                // il ne faut plus afficher la ligne est arrive en haut
                }else{
                    // on efface la ligne de l'cran si elle y tais toujours
                    if(_CreditsOnScreen[i]){
                        _AppLineo->_VTexte->del(_CreditsId[i]);
                        _CreditsOnScreen[i]=false;
                    }
                }
            }
            // on fait toujours monter la ligne sauf quand elle s'approche de 0,
            // de toute faon  ce niveau on est sens ne plus l'afficher
            if(y>30){
                _CreditsY[i]-=offset;
            }else{
                // ceci voudrait dire que le dernier lment  dfil et  disparu  son tour
                // alors on retourne  l'evenement donn  la construction
                if(_CreditsString[i] == _CreditsString.back()){
                    _AppLineo->_Events->addEvent(_EventRetour);
                }
            }
        }
    }
}


// gre les vnements de la vue
void VueCredits::processEvents(SDL_Event *event)
{
    switch (event->type) {
        case SDL_MOUSEBUTTONUP:
        case SDL_KEYDOWN:
            // on retourne  l'evenement donn  la construction lors de l'appui sur une touche du clavier
            _AppLineo->_Events->addEvent(_EventRetour);
        break;
   	}
}
