//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA



#ifndef __VUECREDITS_H__
#define __VUECREDITS_H__

#include "Defines.h"
#include "Screen.h"
#include "Events.h"
#include "VFont.h"
#include "VTexte.h"
#include "FondEcran.h"
#include "Langue.h"

#define CREDITS_BANDES_SPRITE_NAME "credits_bandes_sprite_name"

#define CREDITS_FT_GROS_TITRE 	FONT_36_WHITE
#define CREDITS_FT_TITRE 		FONT_24_WHITE
#define CREDITS_FT_TEXTE 		FONT_26_WHITE
#define CREDITS_FT_TEXTE_JAUNE 	FONT_26_YELLOW
#define CREDITS_FT_COMMENTAIRE 	FONT_18_WHITE

#define CREDITS_FT_MARGE_GROS_TITRE     20
#define CREDITS_FT_MARGE_TITRE          60
#define CREDITS_FT_MARGE_TEXTE          10
#define CREDITS_FT_MARGE_TEXTE_JAUNE    5
#define CREDITS_FT_MARGE_COMMENTAIRE    2

class Lineo;

using namespace std;

typedef vector<string> vstring;
typedef vector<Uint16> vUint16;
typedef vector<Uint32> vUint32;
typedef vector<bool> vbool;

// No description
class VueCredits
{
  //*******************
  //* variables membres
	private:
	    Lineo *_AppLineo;
        vstring     _CreditsString;
        vUint32		_CreditsId;
        vstring     _CreditsFont;
        vUint16     _CreditsY;
        vUint32     _CreditsH;
        vbool       _CreditsOnScreen; // permet de savoir si le texte est affich dans vfont ou non

        Uint32      _LastGetTicks;
        double      _OffsetCumule;

        Uint16      _EventRetour;

        FondEcran*  _FondEcran;

  //*******************
  //* fonctions membres
	public:
		VueCredits(Lineo *app_lineo, Uint16 event_retour);
		~VueCredits();
		void init(void);
		void processEvents(SDL_Event *event);
        bool drawScreen(void);
        bool freeScreen(void);
        void refreshScreen(void);
};

#endif // __VUECREDITS_H__
