//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "VueDessus.h"
#include "Lineo.h"

VueDessus::VueDessus(Lineo* app_lineo)
{
	_AppLineo = app_lineo;
    // on initialise les 16 coordonnes du plateau
    for(Uint8 i=0;i<4;i++){
        for(Uint8 j=0;j<4;j++){
            _PlateauPoints[i][j].x = VD_OFFSET_PT_0_X + VD_DST_ENTRE_PT * i;
            _PlateauPoints[i][j].y = VD_OFFSET_PT_0_Y + VD_DST_ENTRE_PT * j;
        }
    }
    // on initialise les 16 pices du plateau  NULL
    for(Uint8 i=0;i<4;i++){
        for(Uint8 j=0;j<4;j++){
            _PlateauPieces[i][j]=NULL;
        }
    }
    // d'abord le plateau
    SDL_Rect rec_src,rec_des;
    rec_src.x=0;
    rec_des.x=VD_OFFSET_X;
    rec_src.y=0;
    rec_des.y=VD_OFFSET_Y;
    rec_src.w=rec_des.w=173;
    rec_src.h=rec_des.h=183;
    _AppLineo->_Screen->addSprite("plateau_vue_dessus",(string)(DATA_PATH)+"game/plateau_vue_dessus.png",Z_VUE_DESSUS);
    _AppLineo->_Screen->addSpriteImage("plateau_vue_dessus",rec_src,rec_des);
}

VueDessus::~VueDessus()
{
    // d'abord le plateau
    _AppLineo->_Screen->delSprite("plateau_vue_dessus");
    // puis les pices
    for(Uint8 i=0;i<4;i++){
        for(Uint8 j=0;j<4;j++){
            delete(_PlateauPieces[i][j]);
        }
    }
}

// ajoute une pice sur le plateau
void VueDessus::addPlateauPiece(Uint8 i, Uint8 j, Uint8 forme)
{
    if(i<4 && j<4){
        if(_PlateauPieces[i][j]!=NULL){
            delPlateauPiece(i,j);
        }
        // on cr la pice
        _PlateauPieces[i][j]= new MiniPiece(_AppLineo, forme);
        // puis on l'affiche dans Screen
        _PlateauPieces[i][j]->drawScreen(_PlateauPoints[i][j].x+VD_OFFSET_X,_PlateauPoints[i][j].y+VD_OFFSET_Y,Z_VUE_DESSUS+_PlateauPoints[i][j].y);
    }
}

// supprime une pice sur le plateau
void VueDessus::delPlateauPiece(Uint8 i, Uint8 j)
{
    if(i<4 && j<4 && _PlateauPieces[i][j]!=NULL){
        delete(_PlateauPieces[i][j]);
        _PlateauPieces[i][j]=NULL;
    }
}

// surligne une pice afin d'indiquer qu'elle appartient  un Lineo
void VueDessus::setLineo(Uint8 i, Uint8 j)
{
    // on entoure la pice
    if(_PlateauPieces[i][j]!=NULL){
        _PlateauPieces[i][j]->setSelected(true);
    }
}

