//  Lino
//  Copyright (C) 2005-2006 Jonathan Buron <nathan@natsimhan.com>
//  Copyright (C) 2005 Pierre-Yves Bonnefoy <pyb@natsimhan.com>
//
//  This file is part of Lino.
//
//  Lino is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  Lino is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with Lino; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "VueMainMenu.h"
#include "Lineo.h"

VueMainMenu::VueMainMenu(Lineo* app_lineo)
{
	_AppLineo = app_lineo;
    // on initialise le fond d'cran
    _FondEcran = new FondEcran(_AppLineo, FD_ECR_VIERGE|FD_ECR_LINEO_SMALL);
    // on initialise le menu
    _Menu = new Menu(_AppLineo, _AppLineo->_Langue->get("Menu") , false, 0);
    _Menu->addItem(_AppLineo->_Langue->get("Jouer une partie"),EVENT_CREATE_VUE_CHOIX_JOUER);
    _Menu->addItem(_AppLineo->_Langue->get("Niveau"),EVENT_CREATE_VUE_NIVEAU);
//    _Menu->addItem(_AppLineo->_Langue->get("Statistiques"),EVENT_CREATE_VUE_CONSTRUCTION,MENU_TYPE_LIEN,EVENT_CREATE_VUE_MAIN_MENU);
    _Menu->addItem(_AppLineo->_Langue->get("Options"),EVENT_CREATE_VUE_OPTION);
#ifndef Nokia770
    _Menu->addItem(_AppLineo->_Langue->get("Comment jouer..."),EVENT_CREATE_VUE_HOW_TO_PLAY);
#endif
    _Menu->addItem(_AppLineo->_Langue->get("Credits"),EVENT_CREATE_VUE_CREDITS,MENU_TYPE_LIEN,EVENT_CREATE_VUE_MAIN_MENU);
    _Menu->addItem(_AppLineo->_Langue->get("Quitter"),EVENT_CREATE_VUE_CREDITS,MENU_TYPE_LIEN,EVENT_CREATE_VUE_GENERIQUE_FIN);
    _Menu->draw();
}

VueMainMenu::~VueMainMenu()
{
    // on supprime toutes les classes
	delete(_FondEcran);
    delete(_Menu);
}

// gre les vnements de la vue
void VueMainMenu::processEvents(SDL_Event *event)
{
    _Menu->processEvents(event);
}
